#!/usr/bin/env ruby

$VERBOSE = nil

# news: http://pgl.yoyo.org/adservers/rss/adservers.rss

tmpfile = '/mnt/ramd/dnsmasq_ads.conf'
local   = File.expand_path(File.dirname(__FILE__)) + '/dnsmasq-adsblock-entries.gz'
remote  = "http://pgl.yoyo.org/adservers/serverlist.php?hostformat=dnsmasq&showintro=0&mimetype=plaintext"
exclude = %w{
  shinystat
}.join "\\|"

print "downloading updated list...\r"
list_new = `wget -q -O - "#{remote}" | grep -v "#{exclude}"`.to_s.split("\n")
list_old = `gunzip -c #{local}`.to_s.split("\n")
list     = (list_old + list_new).sort.uniq

puts "cur entries: old(#{list_old.size}) / new(#{list_new.size})"
puts "new entries: #{list.size - list_old.size}"
puts "total      : #{list.size}"
puts ''

# write down new rules
File.open(tmpfile,'w'){|f| f.puts list.join("\n")}

# update db if changed
if (list.size - list_old.size) > 0
  system "gzip -c #{tmpfile} > #{local}"
  system "sudo cp -f #{tmpfile} /etc/dnsmasq.d/ads.conf"
  File.unlink tmpfile
  system "wc -l /etc/dnsmasq.d/ads.conf"
end
